VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form FTaskMgr 
   Caption         =   "Visual Basic Task Manager"
   ClientHeight    =   6390
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6315
   Icon            =   "FTaskList.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   6390
   ScaleWidth      =   6315
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   5115
      Left            =   180
      TabIndex        =   5
      Top             =   480
      Width           =   5115
      Begin VB.CommandButton Command1 
         Caption         =   "New Task..."
         Height          =   375
         Index           =   2
         Left            =   3720
         TabIndex        =   3
         Top             =   4560
         Width           =   1215
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Switch To"
         Height          =   375
         Index           =   1
         Left            =   2460
         TabIndex        =   2
         Top             =   4560
         Width           =   1215
      End
      Begin VB.CommandButton Command1 
         Caption         =   "End Task"
         Height          =   375
         Index           =   0
         Left            =   1200
         TabIndex        =   1
         Top             =   4560
         Width           =   1215
      End
      Begin ComctlLib.ListView ListView1 
         Height          =   4215
         Left            =   120
         TabIndex        =   0
         Top             =   180
         Width           =   4875
         _ExtentX        =   8599
         _ExtentY        =   7435
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   327682
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
   End
   Begin ComctlLib.TabStrip TabStrip1 
      Height          =   5655
      Left            =   60
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   120
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   9975
      _Version        =   327682
      BeginProperty Tabs {0713E432-850A-101B-AFC0-4210102A8DA7} 
         NumTabs         =   1
         BeginProperty Tab1 {0713F341-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Applications"
            Key             =   ""
            Object.Tag             =   ""
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   5760
      Top             =   600
   End
   Begin VB.Image Image2 
      Height          =   480
      Left            =   5700
      Picture         =   "FTaskList.frx":0442
      Top             =   2580
      Width           =   480
   End
   Begin VB.Image Image1 
      Height          =   240
      Left            =   5940
      Picture         =   "FTaskList.frx":074C
      Top             =   2160
      Visible         =   0   'False
      Width           =   240
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   5640
      Top             =   1380
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
End
Attribute VB_Name = "FTaskMgr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 1998-2000 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

' Used to cache owner window handle:
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_HWNDPARENT = (-8)

Private tasks As CTaskList
Private m_hWndOwner As Long

' Control indices
Private Const cEndTask = 0
Private Const cSwitchTo = 1
Private Const cNewTask = 2

' Subitem fields
Private Const iStatus = 1
Private Const iHandle = 2

Private Sub Command1_Click(Index As Integer)
   Dim hWnd As Long
   Const RunCaption = "Create New Task"
   
   ' Retrieve hWnd for selected item
   If Not ListView1.SelectedItem Is Nothing Then
      hWnd = CLng(ListView1.SelectedItem.SubItems(2))
   End If
   
   ' Act on user request
   Select Case Index
      Case cEndTask
         MsgBox "Not implemented at deadline." & vbCrLf & vbCrLf & _
            "Please see http://www.mvps.org/vb" & vbCrLf & _
            "for the most recent updates.", vbInformation, _
            "Sorry :-("
      
      Case cSwitchTo
         If hWnd Then
            tasks.Activate hWnd:=hWnd
            Me.WindowState = vbMinimized
         End If
         
      Case cNewTask
         Call ShowRunDialog1( _
            hWndOwner:=Me.hWnd, _
            Caption:=RunCaption, _
            Description:="Type the name of a folder, program, Internet resource, or document, and Visual Basic will open it for you.", _
            hIcon:=Image2.Picture.Handle)
   
         'Call ShowRunDialog2( _
            hWndOwner:=Me.hWnd, _
            Caption:=RunCaption, _
            Description:="Type the name of a folder, program, Internet resource, or document, and Visual Basic will open it for you.", _
            hIcon:=Image2.Picture.Handle)
   
   End Select
End Sub

Private Sub Form_Activate()
   ' Set initial column widths
   With ListView1
      .ColumnHeaders(1).Width = .Width * 0.65
      .ColumnHeaders(2).Width = .Width * 0.25
      .ColumnHeaders(3).Width = .Width * 0.25
   End With
   ' Fill listview
   Call RefreshTaskList
   ' Start without any task selected,
   ' and switch/end buttons disabled.
   Set ListView1.SelectedItem = Nothing
   Command1(cEndTask).Enabled = False
   Command1(cSwitchTo).Enabled = False
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
   ' Offer user keyboard method to unload.
   If KeyAscii = vbKeyEscape Then
      Unload Me
   End If
End Sub

Private Sub Form_Load()
   Dim clm As ColumnHeader
   ' Setup imagelist
   With ImageList1
      .ImageHeight = 16
      .ImageWidth = 16
      .UseMaskColor = False
      .ListImages.Add , "null", Image1.Picture
   End With
   ' Setup listview
   With ListView1
      .View = lvwReport
      Set clm = .ColumnHeaders.Add(, , "Task")
      Set clm = .ColumnHeaders.Add(, , "Status", .Width / 5)
      Set clm = .ColumnHeaders.Add(, , "hWnd")
      .SortOrder = lvwDescending
      Set .SmallIcons = ImageList1
      .HideSelection = False
   End With
   ' Setup task class
   Set tasks = New CTaskList
   tasks.Mode = tlTaskMgr
   tasks.HungTimeout = 250
   ' Sync colors
   Frame1.BackColor = Me.BackColor
   ' Setup timer
   Timer1.Interval = 1000
   Timer1.Enabled = True
   ' Let the world know who we are
   App.Title = Me.Caption
   ' Store handle to hidden owner window.
   m_hWndOwner = GetWindowLong(Me.hWnd, GWL_HWNDPARENT)
End Sub

Private Sub Form_Resize()
   Dim Margin As Long
   Dim BtnWidth As Long
   
   ' Cache a few common values
   Margin = ListView1.Left
   BtnWidth = Command1(cEndTask).Width
   
   On Error Resume Next
   With TabStrip1
      ' Position tabstrip on form and frame within tab
      .Move .Left, .Left, Me.ScaleWidth - .Left * 2, Me.ScaleHeight - .Left * 2
      Frame1.Move .ClientLeft, .ClientTop, .ClientWidth, .ClientHeight
   End With
   With Frame1
      ' Position listview within frame
      ListView1.Move Margin, Margin, .Width - Margin * 2, .Height - Margin * 3 - Command1(cEndTask).Height
      ' Position command buttons
      Command1(cNewTask).Move .Width - BtnWidth - Margin, .Height - Margin - Command1(cNewTask).Height
      Command1(cSwitchTo).Move Command1(cNewTask).Left - BtnWidth - Margin \ 2, Command1(cNewTask).Top
      Command1(cEndTask).Move Command1(cSwitchTo).Left - BtnWidth - Margin \ 2, Command1(cNewTask).Top
   End With
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)
   Select Case ColumnHeader.Index
      Case 1
         ' Toggle sort order
         With ListView1
            If .SortOrder = lvwAscending Then
               .SortOrder = lvwDescending
            Else
               .SortOrder = lvwAscending
            End If
            .Sorted = True
            .Sorted = False
         End With
         
      Case 2
         ' Refresh listview
         Call RefreshTaskList
   End Select
End Sub

Private Sub ListView1_DblClick()
   ' Switch to selected task.
   Call Command1_Click(cSwitchTo)
End Sub

Private Sub ListView1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   Dim itm As ListItem
   ' Select item under mouse, or clear
   ' selection if nothing there.
   With ListView1
      Set itm = .HitTest(x, y)
      If itm Is Nothing Then
         Set .SelectedItem = Nothing
      End If
      Command1(cEndTask).Enabled = Not (.SelectedItem Is Nothing)
      Command1(cSwitchTo).Enabled = Not (.SelectedItem Is Nothing)
   End With
End Sub

Private Sub Timer1_Timer()
   ' Refresh listview
   Call RefreshTaskList
End Sub

Private Sub RefreshTaskList()
   Dim i As Long
   Dim key As String
   Dim itm As ListItem
   Dim nStatus As TaskStatus
   
   ' Remove tasks no longer running
   With ListView1.ListItems
      For i = .Count To 1 Step -1
         If tasks.Valid(hWnd:=CLng(.Item(i).SubItems(iHandle))) = False Then
            .Remove i
         End If
      Next i
   End With
   
   ' Refresh task list
   tasks.Refresh

   ' Add tasks just started, and update
   ' status for tasks already running.
   For i = 1 To tasks.Count
   
      ' No need to display our own task.
      If tasks.hWnd(i) <> m_hWndOwner Then
      
         ' Build key and add item to listview, if
         ' not there already. Otherwise, just grab
         ' reference to existing listitem.
         key = "h" & Hex(tasks.hWnd(i))
         On Error Resume Next
            Set itm = ListView1.ListItems.Add(, key, tasks.Caption(i))
            If Err.Number Then
               Set itm = ListView1.ListItems(key)
            End If
         On Error GoTo 0
         
         ' Use assigned icon as indicator
         ' of whether this is a new task
         ' or one already in the list.
         If itm.SmallIcon = "" Then
            ' Add associated icon to listview.
            On Error Resume Next
            ImageList1.ListImages.Add , key, CreatePicture(tasks.hIconSm(i), vbPicTypeIcon)
            On Error GoTo 0
            itm.SmallIcon = key
            
            ' Add hWnd to 3rd column.
            itm.SubItems(iHandle) = "&" & key
         End If
         
         ' Check responsiveness status of task.
         nStatus = tasks.Status(i)
         
         ' VB5 Listview will "EnsureVisible" selected
         ' entry if subitems needlessly updated.
         If itm.Text <> tasks.Caption(i) Then
            itm.Text = tasks.Caption(i)
         End If
         If itm.Tag <> CStr(nStatus) Then
            If nStatus = tlStatusOK Then
               itm.SubItems(iStatus) = "Running"
            Else
               itm.SubItems(iStatus) = "Not Responding"
            End If
            itm.Tag = CStr(nStatus)
         End If
         
      End If
   Next i
End Sub

